*$ CREATE SOURCE.FOR
*COPY SOURCE
*
*=== source ===========================================================*
*
      SUBROUTINE SOURCE ( NOMORE )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1990-2006      by    Alfredo Ferrari & Paola Sala  *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     New source for FLUKA9x-FLUKA200x:                                *
*                                                                      *
*     Created on 07 january 1990   by    Alfredo Ferrari & Paola Sala  *
*                                                   Infn - Milan       *
*                                                                      *
*     Last change on 03-mar-06     by    Alfredo Ferrari               *
*                                                                      *
*  This is just an example of a possible user written source routine.  *
*  note that the beam card still has some meaning - in the scoring the *
*  maximum momentum used in deciding the binning is taken from the     *
*  beam momentum.  Other beam card parameters are obsolete.            *
*                                                                      *
*----------------------------------------------------------------------*
*
      INCLUDE '(BEAMCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(IOIOCM)'
      INCLUDE '(LTCLCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(SOURCM)'
      INCLUDE '(SUMCOU)'
*
      LOGICAL LFIRST
*
      SAVE LFIRST
      DATA LFIRST / .TRUE. /
*======================================================================*
*                                                                      *
*                 BASIC VERSION                                        *
*                                                                      *
*======================================================================*
      NOMORE = 0
*  +-------------------------------------------------------------------*
*  |  First call initializations:
      IF ( LFIRST ) THEN
*  |  *** The following 3 cards are mandatory ***
         TKESUM = ZERZER
         LFIRST = .FALSE.
         LUSSRC = .TRUE.
*  |  *** User initialization ***
      END IF
*  |
*  +-------------------------------------------------------------------*
*  Push one source particle to the stack. Note that you could as well
*  push many but this way we reserve a maximum amount of space in the
*  stack for the secondaries to be generated
* Npflka is the stack counter: of course any time source is called it
* must be =0
      NPFLKA = NPFLKA + 1
* Wt is the weight of the particle
      WTFLK  (NPFLKA) = ONEONE
      WEIPRI = WEIPRI + WTFLK (NPFLKA)
* Particle type (1=proton.....). Ijbeam is the type set by the BEAM
* card
      IONID = IJBEAM
      ILOFLK (NPFLKA) = IJBEAM
* From this point .....
* Particle generation (1 for primaries)
      LOFLK  (NPFLKA) = 1
* User dependent flag:
      LOUSE  (NPFLKA) = 0
* User dependent spare variables:
      DO 100 ISPR = 1, MKBMX1
         SPAREK (ISPR,NPFLKA) = ZERZER
 100  CONTINUE
* User dependent spare flags:
      DO 200 ISPR = 1, MKBMX2
         ISPARK (ISPR,NPFLKA) = 0
 200  CONTINUE
* Save the track number of the stack particle:
      ISPARK (MKBMX2,NPFLKA) = NPFLKA
      NPARMA = NPARMA + 1
      NUMPAR (NPFLKA) = NPARMA
      NEVENT (NPFLKA) = 0
      DFNEAR (NPFLKA) = +ZERZER
* ... to this point: don't change anything
* Particle age (s)
      AGESTK (NPFLKA) = +ZERZER
      AKNSHR (NPFLKA) = -TWOTWO
* Group number for "low" energy neutrons, set to 0 anyway
      IGROUP (NPFLKA) = 0
************************************************************************
*                                                                      *
*   Sajat kod                                                          *
*                                                                      *
************************************************************************
* Kinetic energy of the particle (GeV)
      ENERND = 1.7523796045710E+12 * FLRNDM(DUMMY)
      IF ( ENERND .LT. 4.0551200000000E+11 ) THEN
         TKEFLK (NPFLKA) = 1e-5
      ELSE IF ( ENERND .LT. 6.1452700000000E+11 ) THEN
         TKEFLK (NPFLKA) = 3e-5
      ELSE IF ( ENERND .LT. 7.0031960000000E+11 ) THEN
         TKEFLK (NPFLKA) = 5.5e-5
      ELSE IF ( ENERND .LT. 7.6141610000000E+11 ) THEN
         TKEFLK (NPFLKA) = 8.5e-5
      ELSE IF ( ENERND .LT. 8.1272810000000E+11 ) THEN
         TKEFLK (NPFLKA) = 1.2e-4
      ELSE IF ( ENERND .LT. 9.0104120000000E+11 ) THEN
         TKEFLK (NPFLKA) = 1.7e-4
      ELSE IF ( ENERND .LT. 9.7346520000000E+11 ) THEN
         TKEFLK (NPFLKA) = 3e-4
      ELSE IF ( ENERND .LT. 1.6524652000000E+12 ) THEN
         TKEFLK (NPFLKA) = 6.5e-4
      ELSE IF ( ENERND .LT. 1.6624653000000E+12 ) THEN
         TKEFLK (NPFLKA) = 1.13e-3
      ELSE IF ( ENERND .LT. 1.7467653000000E+12 ) THEN
         TKEFLK (NPFLKA) = 1.58e-3
      ELSE IF ( ENERND .LT. 1.7483153000000E+12 ) THEN
         TKEFLK (NPFLKA) = 2e-3
      ELSE IF ( ENERND .LT. 1.7522953000000E+12 ) THEN
         TKEFLK (NPFLKA) = 2.4e-3
      ELSE IF ( ENERND .LT. 1.7523540044000E+12 ) THEN
         TKEFLK (NPFLKA) = 2.8e-3
      ELSE IF ( ENERND .LT. 1.7523796044000E+12 ) THEN
         TKEFLK (NPFLKA) = 3.25e-3
      ELSE IF ( ENERND .LT. 1.7523796045699E+12 ) THEN
         TKEFLK (NPFLKA) = 3.75e-3
      ELSE IF ( ENERND .LT. 1.7523796045704E+12 ) THEN
         TKEFLK (NPFLKA) = 4.25e-3
      ELSE IF ( ENERND .LT. 1.7523796045707E+12 ) THEN
         TKEFLK (NPFLKA) = 4.75e-3
      ELSE
         TKEFLK (NPFLKA) = 5.5e-3
      END IF
************************************************************************
* Particle momentum
      PMOFLK (NPFLKA) = SQRT ( TKEFLK (NPFLKA) * ( TKEFLK (NPFLKA)
     &                       + TWOTWO * AM (IONID) ) )
* Cosines (tx,ty,tz)
      CALL RACO(TXX,TYY,TZZ)
      TXFLK  (NPFLKA) = TXX
      TYFLK  (NPFLKA) = TYY
      TZFLK  (NPFLKA) = TZZ
* Polarization cosines:
      TXPOL  (NPFLKA) = -TWOTWO
      TYPOL  (NPFLKA) = +ZERZER
      TZPOL  (NPFLKA) = +ZERZER
************************************************************************
* Palca kisorsolasa
      PALCA = 16 * FLRNDM(DUMMY)
      IF ( PALCA .LT. 1 ) THEN
         PXX = -2.55
         PYY = -2.55
      ELSE IF ( PALCA .LT. 2 ) THEN
         PXX = -0.85
         PYY = -2.55
      ELSE IF ( PALCA .LT. 3 ) THEN
         PXX = 0.85
         PYY = -2.55
      ELSE IF ( PALCA .LT. 4 ) THEN
         PXX = 2.55
         PYY = -2.55
      ELSE IF ( PALCA .LT. 5 ) THEN
         PXX = -2.55
         PYY = -0.85
      ELSE IF ( PALCA .LT. 6 ) THEN
         PXX = -0.85
         PYY = -0.85
      ELSE IF ( PALCA .LT. 7 ) THEN
         PXX = 0.85
         PYY = -0.85
      ELSE IF ( PALCA .LT. 8 ) THEN
         PXX = 2.55
         PYY = -0.85
      ELSE IF ( PALCA .LT. 9 ) THEN
         PXX = -2.55
         PYY = 0.85
      ELSE IF ( PALCA .LT. 10 ) THEN
         PXX = -0.85
         PYY = 0.85
      ELSE IF ( PALCA .LT. 11 ) THEN
         PXX = 0.85
         PYY = 0.85
      ELSE IF ( PALCA .LT. 12 ) THEN
         PXX = 2.55
         PYY = 0.85
      ELSE IF ( PALCA .LT. 13 ) THEN
         PXX = -2.55
         PYY = 2.55
      ELSE IF ( PALCA .LT. 14 ) THEN
         PXX = -0.85
         PYY = 2.55
      ELSE IF ( PALCA .LT. 15 ) THEN
         PXX = 0.85
         PYY = 2.55
      ELSE
         PXX = 2.55
         PYY = 2.55
      END IF
* Particle coordinates
      CALL SFECFE(SFE,CFE)
      RRR = 0.38 * SQRT( FLRNDM(DUMMY) )
      XFLK   (NPFLKA) = RRR * CFE + WHASOU(1) + PXX
      YFLK   (NPFLKA) = RRR * SFE + WHASOU(2) + PYY
      ZFLK   (NPFLKA) = WHASOU(3) - 25 + FLRNDM(DUMMY) * 50
************************************************************************
*                                                                      *
*   Sajat kod vege                                                     *
*                                                                      *
************************************************************************
*  Calculate the total kinetic energy of the primaries: don't change
      IF ( ILOFLK (NPFLKA) .EQ. -2 .OR. ILOFLK (NPFLKA) .GT. 100000 )
     &   THEN
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      ELSE IF ( ILOFLK (NPFLKA) .NE. 0 ) THEN
         TKESUM = TKESUM + ( TKEFLK (NPFLKA) + AMDISC (ILOFLK(NPFLKA)) )
     &          * WTFLK (NPFLKA)
      ELSE
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      END IF
      RADDLY (NPFLKA) = ZERZER
*  Here we ask for the region number of the hitting point.
*     NREG (NPFLKA) = ...
*  The following line makes the starting region search much more
*  robust if particles are starting very close to a boundary:
      CALL GEOCRS ( TXFLK (NPFLKA), TYFLK (NPFLKA), TZFLK (NPFLKA) )
      CALL GEOREG ( XFLK  (NPFLKA), YFLK  (NPFLKA), ZFLK  (NPFLKA),
     &              NRGFLK(NPFLKA), IDISC )
*  Do not change these cards:
      CALL GEOHSM ( NHSPNT (NPFLKA), 1, -11, MLATTC )
      NLATTC (NPFLKA) = MLATTC
      CMPATH (NPFLKA) = ZERZER
      CALL SOEVSV
      RETURN
*=== End of subroutine Source =========================================*
      END

